Bug 204950 - strace misbehaves if output pipe breaks prematurely
Summary: strace misbehaves if output pipe breaks prematurely
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: strace   
(Show other bugs)
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Roland McGrath
QA Contact: Brian Brock
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2006-09-01 16:56 UTC by Dmitry V. Levin
Modified: 2007-11-30 22:11 UTC (History)
0 users

Fixed In Version: 4.5.15-1
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-01-17 03:04:39 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
strace-4.5.14-alt-trace.patch (656 bytes, patch)
2006-09-01 17:03 UTC, Dmitry V. Levin
no flags Details | Diff

Description Dmitry V. Levin 2006-09-01 16:56:10 UTC
When trace output is piped to command and this command terminates prematurely,
strace treats pid of finished pipe process as one of children it have to handle.
As result, strace either fails with "unknown pid" message or (in -f mode) loops waiting for non-existent child.

For example,
$ strace -o '|true' true; echo rc=$?
unknown pid: 12345
rc=1
$ strace -f -o '|true' true
[strace falls asleep forever]

Comment 1 Dmitry V. Levin 2006-09-01 17:03:08 UTC
Created attachment 135392 [details]
strace-4.5.14-alt-trace.patch

Proposed fix.

Comment 2 Dmitry V. Levin 2006-12-13 21:45:51 UTC
Fixed upstream.

Comment 3 Roland McGrath 2007-01-11 11:14:02 UTC
these bugs are fixed upstream in the coming 4.5.15 release

Comment 4 Roland McGrath 2007-01-17 03:04:39 UTC
4.5.15 in rawhide and in updates for fc5 and fc6 fixes this.


Note You need to log in before you can comment on or make changes to this bug.